'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.select = select;
exports.reduce = reduce;
exports.call = call;
exports.fork = fork;
exports.cancel = cancel;

var _CommandTypes = require('./CommandTypes');

function select() {
  var selector = arguments.length <= 0 || arguments[0] === undefined ? function (state) {
    return state;
  } : arguments[0];

  return { type: _CommandTypes.SELECT, selector: selector };
};

function reduce(reducer) {
  return { type: _CommandTypes.REDUCE, reducer: reducer };
};

function call(fn) {
  for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  return { type: _CommandTypes.CALL, fn: fn, args: args };
};

function fork(actionCreator) {
  for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    args[_key2 - 1] = arguments[_key2];
  }

  return { type: _CommandTypes.FORK, actionCreator: actionCreator, args: args };
};

function cancel(actionId) {
  return { type: _CommandTypes.CANCEL, actionId: actionId };
};